<?php

namespace app\admin\controller\student;

use app\common\controller\Backend;
use app\common\model\Config as ConfigModel;
use app\admin\model\Report;
use app\admin\model\Fault;
use think\exception\DbException;
use think\exception\PDOException;
use think\exception\ValidateException;
use think\response\Json;
use think\Db;
use think\Env;
/**
 *
 * @icon fa fa-circle-o
 */
class Collection extends Backend
{

    /**
     * Collection模型对象
     * @var \app\admin\model\teacher\Collection
     */
    protected $model = null;
    protected $exam_model = null;

    protected $whereExtend = null;

    protected $noNeedLogin = ['addreport','editreport','delreport'];

    public function _initialize()
    {
        parent::_initialize();
        $this->model = new \app\admin\model\teacher\Collection;
        $this->exam_model = new \app\admin\model\teacher\Exams;
        $this->assignConfig('sim_sim_type', ConfigModel::getSimTypeList());
        $this->assignConfig('sim_question_setting_method', ConfigModel::getSimQuestionList());
        $this->whereExtend['exam_collection_type'] = 3;
        $this->whereExtend['exam_collection_state'] = 2;
        $this->assignConfig('sim_sim_type', ConfigModel::getSimTypeList());

        $groupIds = $this->auth->getGroupIds();
        //学员查看自己区队的考试集合
        if(in_array(8, $groupIds)){
            $departid = $this->auth->depart_id;
            $this->whereExtend[] = ['exp',Db::raw("FIND_IN_SET($departid,depart_ids)")];
        }
    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */

    /**
     * 查看
     *
     * @return string|Json
     * @throws \think\Exception
     * @throws DbException
     */
    public function index()
    {
        $isset = $this->model->alias('z')
        ->join('real_exam r','z.exam_collection_id=r.exam_collection_id','left')
        ->where('z.exam_collection_type=3 and z.exam_collection_state=2  and r.endtime=0 and r.user_id='.$this->auth->id)->find();

        if(empty($isset)){
            //提示页面，没有开始的考试
            return $this->view->fetch('tishi');
        }else{
            echo "<script>location.href='/admin/student/collection/into/ids/".$isset['exam_collection_id']."'</script>";
        }
        die();
        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if (false === $this->request->isAjax()) {
            return $this->view->fetch();
        }
        //如果发送的来源是 Selectpage，则转发到 Selectpage
        if ($this->request->request('keyField')) {
            return $this->selectpage();
        }
        [$where, $sort, $order, $offset, $limit] = $this->buildparams();
        $list = $this->model
            ->where($where)->where($this->whereExtend)
            ->order($sort, $order)
            ->paginate($limit);
        foreach ($list as $k => $v){
            $exam_isset =  $this->exam_model->where(['user_id'=>$this->auth->id,'exam_collection_id'=>$v['exam_collection_id'],'exam_collection_type'=>3,'endtime'=>['>',0]])->find();
            if(isset($exam_isset)){
                $v->is_user_examed = 1;
            }else{
                $v->is_user_examed = 0;
            }
        }
        unset($v);
        $result = ['total' => $list->total(), 'rows' => $list->items()];
        return json($result);
    }


    //进入考试
    public function  into($ids = null)
    {
        $row = $this->model->get($ids);
        if(!$row){
            $this->error('未找到记录');
        }
        $info = $this->exam_model->where(['user_id'=>$this->auth->id,'exam_collection_id'=>$ids,'exam_collection_type'=>3,'endtime'=>0])->find();
        if(!empty($info)){
            if(!empty($this->auth->seat_id) && !empty($info['seat_id']) && $this->auth->seat_id!=$info['seat_id']){
                $this->error('已在其他座号有开始的考试，不允许换座号');
            }
            $this->exam_model->where('exam_id',$info['exam_id'])->update(['seat_id'=>$this->auth->seat_id]);
            $info['seat_id'] = $this->auth->seat_id;
//            $sim = Db::name('sim')->where('seat_id',$this->auth->seat_id)->find();
            $sim = Db::name('sim')->where('sim_type',$info['sim_type'])->find();
            $sim_text = '';
            if(!empty($sim)){
                if($sim['sim_state']==1){
                    $sim_text = '在线';
                }else if($sim['sim_state']==2){
                    $sim_text = '模拟器离线';
                }else if($sim['sim_state']==3){
                    $sim_text = '网关离线';
                }else if($sim['sim_state']==4){
                    $sim_text = '硬件故障异常';
                }else if($sim['sim_state']==5){
                    $sim_text = '手动禁用';
                }
            }
//            模拟器状态 0:可用初始化 1:在线 2:模拟器离线 3:网关离线 4:硬件故障异常 5:手动禁用
            $info['sim_text'] = $sim_text;
        }
        if(!empty($info['starttime']))
        {
            echo "<script>location.href='/admin/student/collection/examing/ids/".$info['exam_id']."'</script>";
            die();
        }
        $this->view->assign('info', $info);
        $this->view->assign('row', $row);
        $this->assignConfig('exam_id', $info['exam_id']);
        $this->assignConfig('url_type', config('site.url_type'));
        $this->assignConfig('is_fault', Env::get('app.is_fault'));
        return $this->view->fetch();
    }

    public function examing($ids = null)
    {
        $row = $this->exam_model->get($ids);
        if(!$row){
            $this->error('未找到记录');
        }
        if ($this->request->isPost()) {
            //先请求接口判断，再进行处理
            if(Env::get('app.is_fault')){
                $url = config('site.url_type').'/sim/real-exam/student/exam/submit/'.$ids;
                $ret = json_decode(send_get($url),true);
                if($ret['code']!=200){
                    $this->error($ret['msg']);
                }
            }
            //计算分数，保存记录
            $params = $this->request->post('row/a');

            $result = false;
            $score = 100;
            $fault_one_score = 25;
            $fault_two_score = 25;
            $fault_three_score = 25;

            //故障现象
            $xianxian_score = 0;
            $xianxian_arr = [];
            $xianxian_content = [];

            //故障部位
            $buwei_score= 0;
            $buwei_arr = [];
            $buwei_content = [];

            //可能原因
            $yuanyin_socre= 0;
            $yuanyin_arr = [];
            $yuanyin_content = [];

            //排除方法
            $fangfa_score= 0;
            $fangfa_arr = [];
            $fangfa_content = [];

            Db::startTrans();
            try {
                //更新考试结束时间
                $row->end_time = date('Y-m-d H:i:s');
                $row->endtime = time();
                $row->exam_status = 5;
                $row->other_report = $params['other_report'];
                $result = $row->save();

                $info = $this->exam_model->where(['exam_id'=>$ids])->find();

                //更新故障是否正确
                $fault_list = Db::name('real_exam_fault')->where(['exam_id'=>$ids,'flag'=>1])->select();
                if(!empty($fault_list)){
                    foreach ($fault_list as $k =>$t){
                        $answer_right = 2;
                        if(!empty($t['sim_fault_question_value']) && !empty($t['sim_fault_answer_value'])){
                            if($t['sim_fault_question_value']!=$t['sim_fault_answer_value'] ){
                                //真实故障id 000200010001
                                if($t['sim_fault_answer_value']=='00000000' && $t['fault_id'] !='000200010001'){
                                    $answer_right=2;
                                }
                                $answer_right=1;
                            }
                        }
                        Db::name('real_exam_fault')->where(['ref_id'=>$t['ref_id']])->update(['answer_right'=>$answer_right]);
                    }
                }

                //计算得分，故障是否有扣分  扣分制
                $fault_right_list = Db::name('real_exam_fault')->where(['exam_id'=>$ids,'flag'=>1,'answer_right'=>['>',0]])->select();
                if(!empty($fault_right_list)){
                    if($fault_right_list[0]['answer_right']==1){
                        $fault_one_score = 0;
                    }
                    if($fault_right_list[1]['answer_right']==1){
                        $fault_two_score = 0;
                    }
                    if($fault_right_list[2]['answer_right']==1){
                        $fault_three_score = 0;
                    }
                }

                $fault_right_list = Db::name('real_exam_fault')->where(['exam_id'=>$ids,'flag'=>1])->select();
                //根据故障部位 数组
                $fault_arr = [$fault_right_list[0]['fault_id'],$fault_right_list[1]['fault_id'],$fault_right_list[2]['fault_id']];
                
                //根据故障部位查找，匹配的排除方法
                $paichu_arr = Report::where(['bw_id'=>['in',$fault_arr]])->column('pc_id');
                //根据故障部位查找，匹配可能原因
                $yy_arr = Report::where(['bw_id'=>['in',$fault_arr]])->column('yy_id');

                //查找故障现象 数组
                $partent_fault_id = Fault::where(['fault_id'=>['in',$fault_arr]])->column('parent_fault_id');

                //获取数组
                $other_report = json_decode($params['other_report'],true);
                if(!empty($other_report)){
                    foreach ($other_report as $key => $em){
                        //故障现象
                        $xianxian_arr[] = $em['xx_id'];
                        //故障部位
                        $buwei_arr[] = $em['bw_id'];
                        //可能原因
                        $yuanyin_arr[] = $em['yy_id'];
                        //排除方法
                        $fangfa_arr[] = $em['pc_id'];
                    }
                }
                
                //故障现象 分数 start
                foreach ($partent_fault_id as $k1 =>$t){
                    if(!in_array($t,$xianxian_arr)){
                        $xianxian_score = 1+$xianxian_score;
                        $xianxian_content[] = [
                            'cx_id'=>$t,
                            'cx_type'=>'少写',
                            'cx_name'=>Fault::where(['fault_id'=>$t])->value('name'),
                        ];
                    }
                }
                foreach ($xianxian_arr as $k2 =>$t2){
                    if(!in_array($t2,$partent_fault_id)){
                        $xianxian_score = 1+$xianxian_score;
                        $xianxian_content[] = [
                            'cx_id'=>$t2,
                            'cx_type'=>'错写',
                            'cx_name'=>Fault::where(['fault_id'=>$t2])->value('name'),
                        ];
                    }
                }
                //故障现象 end


                //故障部位 start
                foreach ($fault_arr as $k11 =>$t11){
                    if(!in_array($t11,$buwei_arr)){
                        $buwei_score = 1+$buwei_score;
                        $buwei_content[] = [
                            'cx_id'=>$t11,
                            'cx_type'=>'少写',
                            'cx_name'=>Fault::where(['fault_id'=>$t11])->value('name'),
                        ];
                    }
                }
                foreach ($buwei_arr as $k12 =>$t12){
                    if(!empty($t12) && !in_array($t12,$fault_arr)){
                        //错写
                        $buwei_score = 1+$buwei_score;
                        $buwei_content[] = [
                            'cx_id'=>$t12,
                            'cx_type'=>'错写',
                            'cx_name'=>Fault::where(['fault_id'=>$t12])->value('name'),
                        ];
                    }
                }
                //故障部位 end
                

                //排除方法 start
                //循环固定的排除方法，匹配作答的排除方法
                foreach ($paichu_arr as $k21 =>$t21){
                    if(!in_array($t21,$fangfa_arr)){
                        $fangfa_score = 1+$fangfa_score;
                        $fangfa_content[] = [
                            'cx_id'=>$t21,
                            'cx_type'=>'少写',
                            'cx_name'=>Fault::where(['fault_id'=>$t21])->value('name'),
                        ];
                    }
                }
                //循环作答的排除方法，，匹配固定的排除方法
                foreach ($fangfa_arr as $k22 =>$t22){
                    if(!empty($t22) && !in_array($t22,$paichu_arr)){
                        $fangfa_score = 1+$fangfa_score;
                        $fangfa_content[] = [
                            'cx_id'=>$t22,
                            'cx_type'=>'错写',
                            'cx_name'=>Fault::where(['fault_id'=>$t22])->value('name'),
                        ];
                    }
                }
                //排除方法 end

                //可能原因 start
                //循环固定的可能原因，匹配作答的可能原因
                foreach ($yy_arr as $k31 =>$t31){
                    if(!in_array($t31,$yuanyin_arr)){
                        $yuanyin_socre = 1+$yuanyin_socre;
                        $yuanyin_content[] = [
                            'cx_id'=>$t31,
                            'cx_type'=>'少写',
                            'cx_name'=>Fault::where(['fault_id'=>$t31])->value('name'),
                        ];
                    }
                }
                //循环作答的排除方法，，匹配固定的排除方法
                foreach ($yuanyin_arr as $k32 =>$t32){
                    if(!empty($t32) && !in_array($t32,$yy_arr)){
                        $yuanyin_socre = 1+$yuanyin_socre;
                        $yuanyin_content[] = [
                            'cx_id'=>$t32,
                            'cx_type'=>'错写',
                            'cx_name'=>Fault::where(['fault_id'=>$t32])->value('name'),
                        ];
                    }
                }
                //可能原因 end
                
                $weixiu_score = $xianxian_score+$yuanyin_socre+$buwei_score+$fangfa_score;
                if($weixiu_score>15){
                    $weixiu_score = 15;
                }

                //是否超时
                $overtime_fen = intval((time()-$info['endtime']) / 60);
                if($overtime_fen>=10){
                    $overtime_score = 10;
                }else if($overtime_fen>0 && $overtime_fen<10){
                    $overtime_score = $overtime_fen ;
                }else{
                    $overtime_score =0;
                }
                $fault_score = $score-$fault_one_score-$fault_two_score-$fault_three_score-$weixiu_score-$overtime_score;

                //更新考试结果表
                $params['exam_id'] = $ids;
                $params['total'] = $fault_score;//得分;
                $params['fault_one_score'] = $fault_one_score;//得分;
                $params['fault_two_score'] = $fault_two_score;//得分;
                $params['fault_three_score'] = $fault_three_score;//得分;


                $params['xianxian_score'] = $xianxian_score;//得分;
                $params['xianxian_content'] = json_encode($xianxian_content);//错题;

                $params['yuanyin_socre'] = $yuanyin_socre;//得分;
                $params['yuanyin_content'] = json_encode($yuanyin_content);//错题;

                $params['buwei_score'] = $buwei_score;//得分;
                $params['buwei_content'] = json_encode($buwei_content);//错题;

                $params['fangfa_score'] = $fangfa_score;//得分;
                $params['fangfa_content'] = json_encode($fangfa_content);//错题;

                $params['overtime_score'] = $overtime_score;//得分;
                Db::name('real_exam_score')->insert($params);

                $this->exam_model->where(['exam_id'=>$ids])->update(['total_score'=>$fault_score]);

                Db::commit();
            } catch (ValidateException|PDOException|Exception $e) {
                Db::rollback();
                $this->error($e->getMessage());
            }
            if ($result === false) {
                $this->error(__('No rows were inserted'));
            }
            $this->success('交卷成功,待老师确认成绩','/admin/student/exam/index');
        }
        if(empty($row->starttime)){
            $row->start_time = date('Y-m-d H:i:s');
            $row->starttime = time();
            $row->exam_status = 4;
            $row->save();
        }
        $isloading =1;
        if(empty($row->other_replace)){
            $isloading = 0;
            $row->other_replace = '[{"fault_id":"","request_status":"0"}]';
        }
        $row->other_report_text = !empty($row->other_report) ? json_decode($row->other_report,true) : [];

        $other_report_count = !empty($row->other_report) ? count(json_decode($row->other_report,true)) :0;
        //还未开始考试
        $row->limit_duration = $this->model->where(['exam_collection_id'=>$row['exam_collection_id']])->value('limit_duration');
        if(empty($row->starttime)){
            $timer = 60*$row->limit_duration;
        }else{
            $timer = $row->limit_duration*60 - abs(time() - $row->starttime);
        }

        $row->replace_list =Db::name('real_exam_comp_request')->where(['exam_id'=>$ids])->select();
        $this->assignConfig('ids',$ids);
        $this->assignConfig('timer',$timer);
        $this->assignConfig('isloading',$isloading);
        $this->assignConfig('other_report_count',$other_report_count);
        $this->view->assign('row', $row);

        $departmentdata = [];
        $departmentdata = Fault::where(['replace_part'=>1,'sim_type'=>$row->sim_type])->order('fault_id asc')->select();

        //更换件数据
        $this->view->assign('departmentdata', $departmentdata);

        //故障现象
        $xianxiang = Fault::where(['fault_type'=>1,'sim_type'=>$row->sim_type])->select();
        $this->view->assign('xianxiang', $xianxiang);
        //可能原因
        $yuanyin = Fault::where(['fault_type'=>2,'sim_type'=>$row->sim_type])->select();
        $this->view->assign('yuanyin', $yuanyin);
        //故障部位
        $buwei = Fault::where(['fault_type'=>3,'sim_type'=>$row->sim_type])->select();
        $this->view->assign('buwei', $buwei);
        //排除方法
        $paichu = Fault::where(['fault_type'=>4,'sim_type'=>$row->sim_type])->select();
        $this->view->assign('paichu', $paichu);

        return $this->view->fetch();
    }


    public function replace($ids = null)
    {
        if ($this->request->isPost()) {
            $params = $this->request->post('other_replace','');
            $other_report = $this->request->post('other_report','');
            $param = json_decode($params,true);
            if(!empty($param)){
                $faultid_arr = [];
                foreach ($param as $key=>$item){
                    if(!empty($item['fault_id'])){
                        $isreplace = Db::name('real_exam_comp_request')->where(['exam_id'=>$ids,'fault_id'=>$item['fault_id']])->find();
                        if(empty($isreplace)){
                            $add = [
                                'exam_id'=>$ids,
                                'fault_id'=>$item['fault_id'],
                                'request_status'=>1,
                                'fault_name'=>Db::name('fault')->where('fault_id',$item['fault_id'])->value('replace_name'),
                                'create_by_user_id'=>$this->auth->id,
                                'create_by'=>$this->auth->nickname,
                                'createtime'=>time(),
                                'updatetime'=>time(),
                                'create_time'=>date('Y-m-d H:i:s'),
                                'update_time'=>date('Y-m-d H:i:s'),
                            ];
                            Db::name('real_exam_comp_request')->insert($add);
                            $status = 1;
                        }else{
                            $status = $isreplace['request_status'];
                        }
                        $faultid_arr[] = [
                            'fault_id'=>$item['fault_id'],
                            'request_status'=>$status,
                        ];
                    }
                }
                unset($item);
                $row = $this->exam_model->get($ids);
                $row-> other_replace = $faultid_arr ? json_encode($faultid_arr):'';
                $row-> other_report = $other_report;
                $result = $row->save();
            }
            $this->success('申请成功,待老师审批');
        }
    }

    /**
     * @Notes:添加维修报告
     * @Author: jxb
     * @Date: 2025/1/21
     * @Time: 10:29
     */
    public function addreport($ids = null){
        $row = $this->exam_model->get($ids);
        if(!$row){
            $this->error('未找到记录');
        }
        if ($this->request->isPost()) {
            $unwin = $this->request->post('unwin/a');
            $arr = [];
            if(!empty($unwin)){
                if(empty($unwin['xx_id'])){
                    $this->error('故障现象选项有空白项');
                }
                if(empty($unwin['yy_id'][0])){
                    $this->error('可能原因选项有空白项');
                }
                if(empty($unwin['bw_id'])){
                    $this->error('故障部位选项有空白项');
                }
                if(empty($unwin['pc_id'])){
                    $this->error('排除方法选项有空白项');
                }
                $xx_name = Fault::where('fault_id',$unwin['xx_id'])->value('name');
                $yy_name = Fault::where('fault_id','in',$unwin['yy_id'])->column('name');
                $bw_name = Fault::where('fault_id',$unwin['bw_id'])->value('name');
                $pc_name = Fault::where('fault_id',$unwin['pc_id'])->value('name');
                $arr = [
                    'xh_id' => $unwin['xh_id'],
                    'xx_id' => $unwin['xx_id'],
                    'xx_name'=>$xx_name,
                    'yy_id' => implode(',',$unwin['yy_id']),
                    'yy_name' =>  implode(',',$yy_name),
                    'bw_id' => $unwin['bw_id'],
                    'bw_name' => $bw_name,
                    'pc_id' => $unwin['pc_id'],
                    'pc_name' => $pc_name,
                ];
            }
            $other_report = !empty($row->other_report) ? json_decode($row->other_report,true) : [];
            array_push($other_report,$arr);
            $row->other_report = json_encode($other_report);
            $row->save();
            $this->success();
        }

        //故障现象
        $xianxiang = Fault::where(['fault_type'=>1,'sim_type'=>$row->sim_type])->select();
        $this->view->assign('xianxiang', $xianxiang);
        //可能原因
        $yuanyin = Fault::where(['fault_type'=>2,'sim_type'=>$row->sim_type])->column('fault_id,name');
        $this->view->assign('yuanyin', $yuanyin);
        //故障部位
        $buwei = Fault::where(['fault_type'=>3,'sim_type'=>$row->sim_type])->column('fault_id,name');
        $this->view->assign('buwei', $buwei);
        //排除方法
        $paichu = Fault::where(['fault_type'=>4,'sim_type'=>$row->sim_type])->column('fault_id,name');
        $this->view->assign('paichu', $paichu);

        $row->other_report_count = 0;
        $xxid = [];
        if(!empty($row->other_report)){
            $row->other_report_count = count(json_decode($row->other_report,true));
            $otherreport = json_decode($row->other_report,true);
            foreach ($otherreport as $k  =>$item){
                array_push($xxid,$item['xx_id']);
            }
        }
        $row->xxid = $xxid;
        $this->view->assign('row', $row);
        return $this->view->fetch();
    }

    /**
     * @Notes:编辑报告
     * @Author: jxb
     * @Date: 2025/1/21
     * @Time: 15:04
     */
    public function editreport($ids = null,$xh_id = null){
        $row = $this->exam_model->get($ids);
        if(!$row){
            $this->error('未找到记录');
        }
        if ($this->request->isPost()) {
            $unwin = $this->request->post('unwin/a');
            if(!empty($unwin)){
                if(empty($unwin['xx_id'])){
                    $this->error('故障现象选项有空白项');
                }
                if(empty($unwin['yy_id'][0])){
                    $this->error('可能原因选项有空白项');
                }
                if(empty($unwin['bw_id'])){
                    $this->error('故障部位选项有空白项');
                }
                if(empty($unwin['pc_id'])){
                    $this->error('排除方法选项有空白项');
                }
                $xx_name = Fault::where('fault_id',$unwin['xx_id'])->value('name');
                $yy_name = Fault::where('fault_id','in',$unwin['yy_id'])->column('name');
                $bw_name = Fault::where('fault_id',$unwin['bw_id'])->value('name');
                $pc_name = Fault::where('fault_id',$unwin['pc_id'])->value('name');
                $other_report = !empty($row->other_report) ? json_decode($row->other_report,true) : [];
                foreach ($other_report as $k  =>$item){
                    if($k==$xh_id){
                        $other_report[$k]['xx_id'] =$unwin['xx_id'];
                        $other_report[$k]['xx_name'] =$xx_name;
                        $other_report[$k]['yy_id'] = implode(',',$unwin['yy_id']);
                        $other_report[$k]['yy_name'] =implode(',',$yy_name);
                        $other_report[$k]['bw_id'] = $unwin['bw_id'];
                        $other_report[$k]['bw_name'] =$bw_name;
                        $other_report[$k]['pc_id'] =$unwin['pc_id'];
                        $other_report[$k]['pc_name'] =$pc_name;
                    }
                }
                $row->other_report = json_encode($other_report);
                $row->save();
            }
            $this->success();
        }

        //故障现象
        $xianxiang = Fault::where(['fault_type'=>1,'sim_type'=>$row->sim_type])->select();
        $this->view->assign('xianxiang', $xianxiang);
        //可能原因
        $yuanyin = Fault::where(['fault_type'=>2,'sim_type'=>$row->sim_type])->column('fault_id,name');
        $this->view->assign('yuanyin', $yuanyin);
        //故障部位
        $buwei = Fault::where(['fault_type'=>3,'sim_type'=>$row->sim_type])->column('fault_id,name');
        $this->view->assign('buwei', $buwei);
        //排除方法
        $paichu = Fault::where(['fault_type'=>4,'sim_type'=>$row->sim_type])->column('fault_id,name');
        $this->view->assign('paichu', $paichu);

        $row->other_report_text = [];
        if(!empty($row->other_report)){
            $other_report = json_decode($row->other_report,true);
            foreach ($other_report as $k  =>$item){
                if($k==$xh_id){
                    $row->other_report_text = [
                        'xx_id'=>$item['xx_id'],
                        'yy_id'=>explode(',',$item['yy_id']),
                        'bw_id'=>$item['bw_id'],
                        'pc_id'=>$item['pc_id'],
                        'xh_id'=>$item['xh_id']
                    ];
                }
            }
        }
        $this->view->assign('row', $row);
        return $this->view->fetch();
    }


    /**
     * @Notes:移除 维修报告
     * @Author: jxb
     * @Date: 2025/1/21
     * @Time: 14:45
     */
    public function delreport($ids = null){
        $row = $this->exam_model->get($ids);
        if(!$row){
            $this->error('未找到记录');
        }
        if ($this->request->isPost()) {
            $xh_id = $this->request->post('xh_id');
            if(!empty($row->other_report)){
                $other_report = json_decode($row->other_report,true);
                unset($other_report[$xh_id]);
                $row->other_report = json_encode($other_report);
                $row->save();
            }
            $this->success();
        }
    }

    public function analysis($ids = null)
    {
        $row = $this->exam_model->get($ids);
        if(!$row){
            $this->error('未找到记录');
        }
        if ($this->request->isPost()) {
            $params = $this->request->post('row/a');
            //计算总分到学员考试表
            $this->success('操作成功','/admin/student/collection/index');
        }
        return $this->view->fetch();
    }
}
